Class {
	#name : #HitchAttribute,
	#superclass : #Object,
	#instVars : [
		'name',
		'value'
	],
	#category : #Hitch
}

{ #category : #'private - class factory' }
HitchAttribute class >> getResponsibleAttributeClassFor: anAttribute [

	^ self allSubclasses detect: [ :attrClass | attrClass handlesAttribute: anAttribute  ]
	ifNone: [ self ]
]

{ #category : #'private - class factory' }
HitchAttribute class >> handlesAttribute: anAttribute [

	^ SubclassResponsibility 
]

{ #category : #'instance creation' }
HitchAttribute class >> name: attrName value: attrValue [

	^ (self getResponsibleAttributeClassFor: attrName) new name: attrName value: attrValue
]

{ #category : #rendering }
HitchAttribute >> renderValue [ 
	^ value
]
