"
I am the base concept of an HTML element.

For the Responsibility part: Three sentences about my main responsibilities - what I do, what I know.

For the Collaborators Part: State my main collaborators and one line about how I interact with them.

Public API and Key Messages

- message one
- message two
- (for bonus points) how to create instances.

   One simple example is simply gorgeous.

Internal Representation and Key Implementation Points.

    Instance Variables
	name:		<Object>


    Implementation Points
"
Class {
	#name : #HitchElement,
	#superclass : #Object,
	#instVars : [
		'name',
		'attributes',
		'children'
	],
	#category : #Hitch
}

{ #category : #'private - class factory' }
HitchElement class >> getResponsibleElementClassFor: aTag [

	^ self allSubclasses
		  detect: [ :subclass | subclass handlesTag: aTag ]
		  ifNone: [ self ]
]

{ #category : #'private - class factory' }
HitchElement class >> handlesTag: aTag [

	^ SubclassResponsibility 
]

{ #category : #'instance creation' }
HitchElement class >> tag: aTag [

	^ (self getResponsibleElementClassFor: aTag) new
		  name: aTag;
		  yourself
]

{ #category : #'instance creation' }
HitchElement class >> tag: aTag attrs: attributes [

	^ (self getResponsibleElementClassFor: aTag)
		  new
		  name: aTag;
		  attributes: attributes;
		  yourself
]

{ #category : #'instance creation' }
HitchElement class >> tag: aTag attrs: attributes children: childElems [ 

	^ (self getResponsibleElementClassFor: aTag) new
		  name: aTag;
		  attributes: attributes;
		children: childElems;
		  yourself
]

{ #category : #'instance creation' }
HitchElement class >> tag: aTag children: childElems [

	^ (self getResponsibleElementClassFor: aTag) new
		  name: aTag;
		  children: childElems;
		  yourself
]

{ #category : #adding }
HitchElement >> add: aTag [

	children add: (self class tag: aTag)
]

{ #category : #adding }
HitchElement >> add: aTag attrs: attrs [

	children add: (self class tag: aTag attrs: attrs)
]

{ #category : #adding }
HitchElement >> add: aTag attrs: attrs children: childElems [

	children add: (self class tag: aTag attrs: attrs children: childElems)
]

{ #category : #adding }
HitchElement >> add: aTag children: childElems [

	children add: (self class tag: aTag children: childElems)
]

{ #category : #accessing }
HitchElement >> attributes [

	^ attributes
]

{ #category : #accessing }
HitchElement >> attributes: anObject [

	attributes := anObject
]

{ #category : #accessing }
HitchElement >> children [

	^ children
]

{ #category : #accessing }
HitchElement >> children: anObject [

	children := anObject
]

{ #category : #initialization }
HitchElement >> initialize [ 
attributes ifNil: [ attributes := Dictionary new ].
children ifNil: [ children := OrderedCollection new ]
]

{ #category : #accessing }
HitchElement >> name [

	^ name
]

{ #category : #accessing }
HitchElement >> name: anObject [

	name := anObject
]

{ #category : #rendering }
HitchElement >> render [

	^ '<' , name , ' ' , self renderAttributes , '>\n'
	  , (self renderChildren) , '\n</' , name , '>'
]

{ #category : #rendering }
HitchElement >> renderAttributes [
	^ ' ' join: (attributes do: [ :attribute | '=' join: #( attribute name attribute renderValue ) ]).
]

{ #category : #rendering }
HitchElement >> renderChildren [

	^ '\n\t' join: (children collect: [ :child |
			   child isString
				   ifTrue: [ child ]
				   ifFalse: [ child render ] ])
]
